
;-------------------------------------------
;   TestMCI.asm -- MCI Command String Tester
;
;   based on "C" code by Petzold
;
;                4/6/00
;
;   Ron Thomas Ron_Thom@Compuserve.com
;-------------------------------------------
        .386                            ; 32 bit when .386 or better appears before .model
        .model  flat, stdcall
        option  casemap :none
;
; Includes
;---------------------------------------
        include     \masm32\include\windows.inc
;;;;        include     \masm32\include\masm32.inc

        include     \masm32\include\user32.inc
        include     \masm32\include\kernel32.inc
        include     \masm32\include\gdi32.inc
        include     \masm32\include\winmm.inc
;
; Libraries
;---------------------------------------
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\gdi32.lib
        includelib  \masm32\lib\winmm.lib

WinMain     PROTO :DWORD, :DWORD, :DWORD, :SDWORD
DlgProc     PROTO :DWORD, :DWORD, :DWORD, :DWORD

ID_TIMER        EQU 1
IDC_MAIN_EDIT       EQU 1000
IDC_NOTIFY_MESSAGE  EQU 1005
IDC_NOTIFY_ID       EQU 1006
IDC_NOTIFY_SUCCESSFUL   EQU 1007
IDC_NOTIFY_SUPERSEDED   EQU 1008
IDC_NOTIFY_ABORTED  EQU 1009
IDC_NOTIFY_FAILURE  EQU 1010
IDC_SIGNAL_MESSAGE  EQU 1011
IDC_SIGNAL_ID       EQU 1012
IDC_SIGNAL_PARAM    EQU 1013
IDC_RETURN_STRING   EQU 1014
IDC_ERROR_STRING    EQU 1015
IDC_DEVICES     EQU 1016

.data

CRLF        db  0Dh,0Ah,0
DeviceID    db  "Device ID = %i",0
OutOfSpace  db  "Error control out of space",0
szAppName       db  "TestMCI",0

.data?

hInstance HINSTANCE ?
CommandLine LPSTR ?
hwndEdit    DD  ?
;
;Macros
;---------------------------------------
LOWORD  MACRO bigword       ;; Retrieves the low word from double word argument

    mov eax,bigword
    and eax,0FFFFh  ;; Get low word
    ENDM

HIWORD  MACRO bigword       ;; Retrieves the high word from double word

    mov eax,bigword
    shr eax,16      ;; Shift 16 for high word to set to high word

    ENDM

return MACRO arg
        mov eax, arg
        ret
      ENDM

M2M MACRO   arg1, arg2

    push    arg2
    pop arg1

    ENDM

RGB MACRO red, green, blue  ;; Get composite number from red green and blue bytes

    mov al,blue         ;; ,,,blue
    shl eax,8           ;; ,,blue,

    add al,green        ;; ,,blue,green
    shl eax,8           ;; ,blue,green,
    add al,red          ;; ,blue,green,red
    and eax,0FFFFFFh        ;; Mask out top byte to complete COLORREF dword

    ENDM

MAX MACRO   word1, word2    ;; Return the maximum of 2 integers in eax

    mov ecx,word2
    mov eax,word1

    .IF eax < ecx
       mov  eax,word2   ;; Set word2 as max
    .ENDIF

    ENDM

MIN MACRO   word1, word2    ;; Return the minimum of 2 integers in eax

    mov ecx,word2
    mov eax,word1

    .IF eax > ecx
       mov  eax,word2   ;; Set word2 as min
    .ENDIF

    ENDM
;
;
.code
;---------------------------------------
Start:
    invoke GetModuleHandle, NULL
    mov    hInstance,eax
    invoke GetCommandLine
        invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
    invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD

    invoke  DialogBoxParam, hInst, ADDR szAppName, 0, ADDR DlgProc,0

        return  0

WinMain endp


DlgProc proc uses ebx esi, hWnd:HWND, message:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL rect:RECT
    LOCAL iCharBeg:DWORD, iCharEnd:DWORD, iLineBeg:DWORD, iLineEnd:DWORD
    LOCAL iChar:DWORD, iLine:DWORD, iLength:DWORD, error:DWORD
    LOCAL szCommand[1024]:BYTE, szReturn[1024]:BYTE, szError[1024]:BYTE, szBuffer[32]

    mov eax, message

    .IF eax==WM_INITDIALOG

;       Centre the window on the screen

        invoke GetWindowRect, hWnd, ADDR rect
        invoke GetSystemMetrics, SM_CXSCREEN
        sub eax, rect.right
        add eax, rect.left
        shr eax,1
        push eax

        invoke GetSystemMetrics, SM_CYSCREEN
        sub eax, rect.bottom
        add eax, rect.top
        shr eax,1

        pop ecx
        invoke SetWindowPos, hWnd, 0, ecx, eax, 0,0, SWP_NOZORDER or SWP_NOSIZE

        invoke GetDlgItem, hWnd, IDC_MAIN_EDIT
        mov  hwndEdit, eax
        invoke SetFocus, hwndEdit
        return FALSE

    .ELSEIF eax==WM_COMMAND

        LOWORD wParam

        .IF eax==IDOK

;           Some of the available MCI Controls
;----------------------------------------------------------------------------------------
;   EM_GETSEL   Control. Low order word of return value is the character position
;           of the caret relative to 1st characvter in the edit control.

;   EM_LINEFROMCHAR Control. Obtain the line number of line containing the specified
;           character index. (A character index is the number of chars from
;           the begining of the edit control.

;   EM_GETLINE  Control. Copies a line of text from an edit control and places
;           it in a specified buffer. Note set the first word of this buffer
;           to the number of chars in the buffer. This is over written when
;           the buffer is filled.

;   EM_LINEINDEX    Control. Retieves the character index of a line in the edit control

;   EM_LINELENGTH   Control. Retieve the length of a line in the edit control

;   EM_SETSEL   Control. Selects a range of characters within the edit control,
;           or to place a caret within the edit control. The lParam argument
;           specifies the start and edn character for the selection.
;           Low word is the start and the high word is the end char position.

;   EM_REPLACESEL   Control. Sent to request a replace of the current selection in
;           the edit control. If theres no selection, the text is inserted at
;           the current caret position. An application specifies the new text
;           by passing a pointer to the text in the lParam parameter. Note
;           that the new text must be null terminated.
;----------------------------------------------------------------------------------------

;       Find line numbers corresponding to the selection
;       ------------------------------------------------

        invoke SendMessage, hwndEdit, EM_GETSEL, ADDR iCharBeg, ADDR iCharEnd

        invoke SendMessage, hwndEdit, EM_LINEFROMCHAR, iCharBeg, 0
        mov iLineBeg,eax
        invoke SendMessage, hwndEdit, EM_LINEFROMCHAR, iCharEnd, 0
        mov iLineEnd,eax

;       Loop through all lines
;       ----------------------

        mov  esi, iLineBeg

        .WHILE esi <= iLineEnd

;       Get the line and terminate it; ignore if blank
;       ----------------------------------------------

            lea eax, szCommand          ; Get pointer to Command string
            mov  cx, sizeof szCommand
            mov  word ptr [eax], cx     ; Load size into 1st word of buffer

            invoke SendMessage, hwndEdit, EM_GETLINE, esi, ADDR szCommand

            mov    iLength, eax
            mov  ebx, iLength
            mov byte ptr szCommand[ebx], 0  ; Null terminate the string

            .IF iLength != 0            ; Process if length != 0

;           Send the MCI command
;           --------------------

                invoke mciSendString, ADDR szCommand, ADDR szReturn, sizeof szReturn, hWnd
                mov  error, eax

;           Set the Return String field

                invoke SetDlgItemText, hWnd, IDC_RETURN_STRING, ADDR szReturn

;           Set the Error String field, even if no error

                invoke mciGetErrorString, error, ADDR szError, sizeof szError

                invoke SetDlgItemText, hWnd, IDC_ERROR_STRING, ADDR szError

            .ENDIF

            inc esi
        .ENDW

;       Send the caret to the end of the last selected line
;       ---------------------------------------------------
        invoke SendMessage, hwndEdit, EM_LINEINDEX, iLineEnd, 0
        mov  iChar,eax
        invoke SendMessage, hwndEdit, EM_LINELENGTH, iCharEnd, 0
        add  iChar, eax
        invoke SendMessage, hwndEdit, EM_SETSEL, iChar, iChar

;       Insert CR/LF
;       ------------
        invoke SendMessage, hwndEdit, EM_REPLACESEL, 0, ADDR CRLF
        invoke SetFocus, hwndEdit

        return TRUE

        .ELSEIF eax==IDCANCEL

        invoke EndDialog, hWnd,0
        return TRUE

        .ELSEIF eax==IDC_MAIN_EDIT

        HIWORD wParam

        .IF eax==EN_ERRSPACE

            invoke MessageBox, hWnd, ADDR OutOfSpace, ADDR szAppName, \
                       MB_OK or MB_ICONINFORMATION
            return TRUE
        .ENDIF

        .ENDIF

    .ELSEIF eax==MM_MCINOTIFY

        invoke GetDlgItem, hWnd, IDC_NOTIFY_MESSAGE
        invoke EnableWindow, eax, TRUE

        invoke wsprintf, ADDR szBuffer, ADDR DeviceID, lParam
        invoke SetDlgItemText, hWnd, IDC_NOTIFY_ID, ADDR szBuffer
        invoke GetDlgItem, hWnd, IDC_NOTIFY_ID
            invoke EnableWindow, eax, TRUE      ; Display Device ID

        invoke GetDlgItem, hWnd, IDC_NOTIFY_SUCCESSFUL
        mov    ecx, wParam
        and    ecx, MCI_NOTIFY_SUCCESSFUL
        invoke EnableWindow, eax, ecx       ; Display message in Group box

        invoke GetDlgItem, hWnd, IDC_NOTIFY_SUPERSEDED
        mov    ecx, wParam
        and    ecx, MCI_NOTIFY_SUPERSEDED
        invoke EnableWindow, eax, ecx       ;   ditto

        invoke GetDlgItem, hWnd, IDC_NOTIFY_ABORTED
        mov    ecx, wParam
        and    ecx, MCI_NOTIFY_ABORTED
        invoke EnableWindow, eax, ecx       ;   ditto

        invoke GetDlgItem, hWnd, IDC_NOTIFY_FAILURE
        mov    ecx, wParam
        and    ecx, MCI_NOTIFY_FAILURE
        invoke EnableWindow, eax, ecx       ;   ditto

        invoke SetTimer, hWnd, ID_TIMER, 5000, 0    ; 5 seconds delay for
        return TRUE                 ; showing item in Group box

    .ELSEIF eax==WM_TIMER

        invoke KillTimer, hWnd, ID_TIMER        ; Finish with timer

        invoke GetDlgItem, hWnd, IDC_NOTIFY_MESSAGE
        invoke EnableWindow, eax, FALSE     ; Remove notification
                            ; from the group box
        invoke GetDlgItem, hWnd, IDC_NOTIFY_ID
        invoke EnableWindow, eax, FALSE     ;   ditto

        invoke GetDlgItem, hWnd, IDC_NOTIFY_SUCCESSFUL
        invoke EnableWindow, eax, FALSE     ;   ditto

        invoke GetDlgItem, hWnd, IDC_NOTIFY_SUPERSEDED
        invoke EnableWindow, eax, FALSE     ;   ditto

        invoke GetDlgItem, hWnd, IDC_NOTIFY_ABORTED
        invoke EnableWindow, eax, FALSE     ;   ditto

        invoke GetDlgItem, hWnd, IDC_NOTIFY_FAILURE
        invoke EnableWindow, eax, FALSE     ;   ditto

        return TRUE

    .ELSEIF eax==WM_SYSCOMMAND

        LOWORD   wParam

        .IF eax==SC_CLOSE
        invoke EndDialog, hWnd, 0
            return TRUE
        .ENDIF

    .ENDIF

    return FALSE
DlgProc endp
;
;
        end     Start

